try:
    from cozmo_fsm import *
except:
    raise ImportError("Could not find cozmo_fsm")

class Lab3P2(StateMachineProgram):
    def __init__(self):
        landmarks = {
            'Aruco-0' : Pose(-55, 160, 0, angle_z=degrees(-90)),
            'Aruco-1' : Pose( 55, 160, 0, angle_z=degrees(-90))
        }

        pf = ParticleFilter(robot,
                            landmarks = landmarks,
                            #sensor_model = ArucoDistanceSensorModel(robot)
                            #sensor_model = ArucoBearingSensorModel(robot)
                            sensor_model = ArucoCombinedSensorModel(robot)
        )

        super().__init__(aruco_marker_size=ARUCO_MARKER_SIZE,
                         particle_filter=pf)
    def setup(self):
        """
            turnLeft: Turn(90) =C=> move: Forward(100) =C=> turnRight: Turn(-90)
        """
        
        # Code generated by genfsm on Thu Feb  6 21:59:30 2020:
        
        turnLeft = Turn(90) .set_name("turnLeft") .set_parent(self)
        move = Forward(100) .set_name("move") .set_parent(self)
        turnRight = Turn(-90) .set_name("turnRight") .set_parent(self)
        
        completiontrans1 = CompletionTrans() .set_name("completiontrans1")
        completiontrans1 .add_sources(turnLeft) .add_destinations(move)
        
        completiontrans2 = CompletionTrans() .set_name("completiontrans2")
        completiontrans2 .add_sources(move) .add_destinations(turnRight)
        
        return self

