try:
    from cozmo_fsm import *
except:
    raise ImportError("Could not find cozmo_fsm package.")

data = []

class Record(StateNode):
    def start(self, event=None):
        data.append((robot.pose.position.x, robot.pose.position.y))
        print(data)
        super().start(event)

class Calculate(StateNode):
    def start(self, event=None):
        dists = []
        for i in range(1, len(data)):
            (xprev,yprev) = data[i-1]
            (x,y) = data[i]
            xdiff = x - xprev
            ydiff = y - yprev
            dist = math.sqrt(xdiff * xdiff + ydiff * ydiff)
            dists.append(dist)
        d = sum(dists) / float((len(data)-1))
        print(str(d / 2.0))
        super().start(event)

class MeasureR(StateMachineProgram):
    def setup(self):
        """
            start: StateNode()
            start =N=> loop
    
            loop: Iterate(10)
            loop =D=> record: Record() =N=> Turn(180) =CNext=> loop
            loop =C=> Calculate()
        """
        
        # Code generated by genfsm on Fri Feb  7 15:57:34 2020:
        
        start = StateNode() .set_name("start") .set_parent(self)
        loop = Iterate(10) .set_name("loop") .set_parent(self)
        record = Record() .set_name("record") .set_parent(self)
        turn1 = Turn(180) .set_name("turn1") .set_parent(self)
        calculate1 = Calculate() .set_name("calculate1") .set_parent(self)
        
        nulltrans1 = NullTrans() .set_name("nulltrans1")
        nulltrans1 .add_sources(start) .add_destinations(loop)
        
        datatrans1 = DataTrans() .set_name("datatrans1")
        datatrans1 .add_sources(loop) .add_destinations(record)
        
        nulltrans2 = NullTrans() .set_name("nulltrans2")
        nulltrans2 .add_sources(record) .add_destinations(turn1)
        
        cnexttrans1 = CNextTrans() .set_name("cnexttrans1")
        cnexttrans1 .add_sources(turn1) .add_destinations(loop)
        
        completiontrans1 = CompletionTrans() .set_name("completiontrans1")
        completiontrans1 .add_sources(loop) .add_destinations(calculate1)
        
        return self
